<?php

// Beginn der Control-Komponente (des MVC-Modells).

// Falls die Verbindung zur Datenbank schon besteht, ist dieses Skript unntig.
require_once('connect.inc.php');

require_once('Oeffnungszeiten.class.php');
$offen = new Oeffnungszeiten();

if (isset($_REQUEST['aktion']) && $_REQUEST['aktion'] == 'loeschen')
{
    $offen->removeRegel($_REQUEST['id']);
}
elseif (! empty($_POST['datum']))
{
    $offen->setRegel($_POST);
}

// Ende der Control-Komponente (des MVC-Modells).

// Beginn der View-Komponente (des MVC-Modells).

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="de">
<head>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
  <title>ffnungszeiten</title>
  <meta name="author" content="Thiemo Mttig">
  <meta name="robots" content="noindex,nofollow">
  <style type="text/css">
  <!--
  @media screen{
    *{font-family:Tahoma,Arial,sans-serif;font-size:13px;}
    a:link,a:visited{color:#009;}
    a:hover,a:active{color:#00F;text-decoration:none;}
    h1{font-size:150%;}
    form{background:#EEE;margin:2ex 0;padding:1ex;}
    form p{margin:0;}
    address{color:#999;margin-top:5ex;}

    table{border-collapse:collapse;border-spacing:0;empty-cells:show;}
    th{background:#DDD;border-bottom:1px solid #BBB;text-align:left;}
    th,td{padding:0.5ex 1.5ex;}
    td{border-bottom:1px solid #CCC;}

    #oeffnungszeit{
      background:#FED;border:1px solid #BA9;font-weight:bold;padding:0.5ex 1ex;
      text-align:center;
    }
  }
  -->
  </style>
  <script type="text/javascript">
  <!--
  function showDay()
  {
    var v = "-";
    var r = /([0-9]+)[^0-9]+([0-9]+)[^0-9]+([0-9]+)/;
    if (r.exec(document.forms['offen'].elements['datum'].value))
    {
      var w = new Array("So", "Mo", "Di", "Mi", "Do", "Fr", "Sa");
      v = w[new Date(RegExp.$1, RegExp.$2 - 1, RegExp.$3).getDay()];
    }
    document.forms['offen'].elements['wochentag'].value = v;
  }
  //-->
  </script>
</head>
<body>

<h1>ffnungszeiten</h1>

<form action="<?=$_SERVER['PHP_SELF']?>" method="post" name="offen">
<table>
<tr>
<th>Datum</th><th>Von</th><th>Bis</th><th>Art</th><th>Beschreibung</th>
<th>Aktion</th>
</tr>
<?php
function zeigeFormularZeile($regel)
{
    global $offen;

    echo '<td>';
    if (! empty($regel['id']))
    {
        echo '<input name="id" type="hidden" value="' . $regel['id'] . '">';
    }
    echo '<input maxlength="10" name="datum" size="10" tabindex="1" type="text" value="';
    echo (empty($regel['datum']) ? date('Y-m-d') : $regel['datum']);
    echo '" onkeyup="showDay()" onchange="showDay()">, ';
    echo '<input maxlength="2" name="wochentag" readonly="readonly" size="2"';
    echo ' style="background:#EEE;border:0" type="text" value="';
    if (isset($regel['datum']) && strtotime($regel['datum']) >= 0)
    {
        $regel['wochentag'] = $offen->wochentage[date('w', strtotime($regel['datum']))];
    }
    echo substr(empty($regel['wochentag']) ? $offen->wochentage[date('w')] : $regel['wochentag'], 0, 2);
    echo '"></td>';
    echo '<td><input name="von" maxlength="5" size="5" tabindex="2" type="text" value="';
    echo (empty($regel['von']) ? '00:00' : $regel['von']) . '"></td>';
    echo '<td><input maxlength="5" name="bis" size="5" tabindex="3" type="text" value="';
    echo (empty($regel['bis']) ? '00:00' : $regel['bis']) . '"></td>';
    echo '<td><input id="offen1" name="offen" tabindex="4" type="radio" value="1"';
    if (! empty($regel['offen'])) echo ' checked="checked"';
    echo '><label for="offen1">Geffnet</label><br>';
    echo '<input id="offen0" name="offen" tabindex="4" type="radio" value="0"';
    if (empty($regel['offen'])) echo ' checked="checked"';
    echo '><label for="offen0">Geschlossen</label></td>';
    echo '<td><select name="typ_id" size="1" tabindex="5">';
    foreach ($offen->getTypen() as $typ)
    {
        echo '<option value="' . $typ['id'] . '"';
        if (isset($regel['typ_id']) && $regel['typ_id'] == $typ['id'])
        {
            echo ' selected="selected"';
        }
        echo '>' . htmlspecialchars($typ['beschreibung']) . '</option>';
    }
    echo '</select>';
    echo '<input maxlength="3" name="wert" size="3" tabindex="6" type="text" value="';
    echo (isset($regel['wert']) ? $regel['wert'] : '1') . '"></td>';
    echo '<td><input accesskey="s" tabindex="7" type="submit" value="Speichern"></td>';
}
foreach ($offen->getRegeln() as $regel)
{
    echo '<tr>';
    if (isset($_REQUEST['aktion']) && $_REQUEST['aktion'] == 'bearbeiten' &&
        isset($_REQUEST['id']) && $_REQUEST['id'] == $regel['id'])
    {
        zeigeFormularZeile($regel);
    }
    else
    {
        echo '<td><nobr>' . $regel['datum'] . ', ' . $regel['wochentag'] . '</nobr></td>';
        echo '<td>' . $regel['von'] . '</td>';
        echo '<td>' . $regel['bis'] . '</td>';
        echo '<td>' . ($regel['offen'] ? 'Geffnet' : 'Geschlossen') . '</td>';
        echo '<td>' . htmlspecialchars($regel['beschreibung']) . '</td>';
        echo '<td>';
        echo '<a href="' . $_SERVER['PHP_SELF'] . '?aktion=bearbeiten&id=' .
            $regel['id'] . '">Bearbeiten</a> ';
        echo '<a href="' . $_SERVER['PHP_SELF'] . '?aktion=neu&datum=' .
            date('Y-m-d', strtotime($regel['datum']) + 129600) . '&amp;von=' .
            $regel['von'] . '&amp;bis=' . $regel['bis'] . '&amp;offen=' .
            $regel['offen'] . '&amp;typ_id=' . $regel['typ_id'] . '&amp;wert=' .
            $regel['wert'] . '">Kopieren</a> ';
        echo '<a href="' . $_SERVER['PHP_SELF'] . '?aktion=loeschen&id=' .
            $regel['id'] . '" onclick="return confirm(\'Mchten Sie diese Regel wirklich lschen?\')">Lschen</a>';
        echo '</td>';
    }
    echo '</tr>';
}
?>
<tr>
<?php
if (isset($_REQUEST['aktion']) && $_REQUEST['aktion'] == 'neu')
{
    zeigeFormularZeile($_GET);
}
else
{
    echo '<td colspan="5"></td>';
    echo '<td><a accesskey="n" href="' . $_SERVER['PHP_SELF'] . '?aktion=neu' .
        '">Neue Regel hinzufgen</a></td>';
}
?>
</tr>
</table>
</form>

<?php
if (isset($_REQUEST['tage'])) $tage = $_REQUEST['tage'];
if (empty($tage)) $tage = 14;
?>

<form action="<?=$_SERVER['PHP_SELF']?>" method="post">
<p>
<input name="tage" size="3" type="text" value="<?=$tage?>"> Tage
<input type="submit" value="Vorschau">
</p>
</form>

<p id="oeffnungszeit"><?=$offen->getNaechsteOeffnung($tage)?></p>

<table>
<tr><th>Datum</th><th>ffnungszeiten</th></tr>
<?php
foreach ($offen->getKalender($tage) as $datum => $tag)
{
    echo '<tr>';
    echo '<td>' . $tag['wochentag'] . ', ' . $datum . '</td>';
    echo '<td>' . $tag['beschreibung'] . '</td>';
    echo '<tr>';
}
?>
</table>

<address>Programmiert von <a href="http://maettig.com/">Thiemo Mttig</a></address>

</body>
</html>